unit frmIndex;
{$MODE ObjFPC}
{$H+}

interface

uses js, web, Classes;

type
  
  { --------------------------------------------------------------------
    TIndexForm
    --------------------------------------------------------------------}

  { TIndexForm }

  TIndexForm = class(TComponent)
  Published
    btnLogin : TJSHTMLButtonElement;
    btnProjects : TJSHTMLButtonElement;
    btnUsers : TJSHTMLButtonElement;
    form_parent : TJSHTMLElement;
    procedure DoLoginClick(Event : TJSEvent); 
    procedure DoProjectsClick(Event : TJSEvent);
    procedure DoUsersClick(Event : TJSEvent);
  Private
    FCurrentForm : TComponent;
  Public
    constructor create(aOwner : TComponent); override;
    procedure BindElements; virtual;
    procedure BindElementEvents; virtual;
    Property CurrentForm : TComponent Read FCurrentForm;
  end;

implementation

uses Rtl.TemplateLoader, frmLogin, frmProjects, frmUsers;

{ --------------------------------------------------------------------
  TIndexForm
  --------------------------------------------------------------------}


procedure TIndexForm.DoLoginClick(Event: TJSEvent);

  Procedure ShowLogin;
  begin
    form_parent.innerHTML:=GlobalTemplates.Templates['login'];
    FCurrentForm:=TLoginForm.Create(Self);
  end;

  procedure DoShowLogin(Sender: TObject; const aTemplate: String);
  begin
    ShowLogin;
  end;

begin
  if GlobalTemplates.Templates['login']<>'' then
    ShowLogin
  else
    GlobalTemplates.LoadTemplate('login','login.html',@DoShowLogin);
end;

procedure TIndexForm.DoProjectsClick(Event: TJSEvent);

  Procedure ShowProjects;
  begin
    form_parent.innerHTML:=GlobalTemplates.Templates['projects'];
    FCurrentForm:=TProjectsForm.Create(Self);
  end;

  procedure DoShowProjects(Sender: TObject; const aTemplate: String);
  begin
    ShowProjects;
  end;

begin
  if GlobalTemplates.Templates['projects']<>'' then
    ShowProjects
  else
    GlobalTemplates.LoadTemplate('projects','projects.html',@DoShowProjects);
end;

procedure TIndexForm.DoUsersClick(Event: TJSEvent);

  Procedure ShowUsers;
  begin
    form_parent.innerHTML:=GlobalTemplates.Templates['users'];
    FCurrentForm:=TUsersForm.Create(Self);
  end;

  procedure DoShowUsers(Sender: TObject; const aTemplate: String);
  begin
    ShowUsers;
  end;

begin
  if GlobalTemplates.Templates['users']<>'' then
    ShowUsers
  else
    GlobalTemplates.LoadTemplate('users','users.html',@DoShowUsers);
end;

constructor TIndexForm.create(aOwner : TComponent);

begin
  inherited;
  BindElements;
  BindElementEvents;
end;



procedure TIndexForm.BindElements;

begin
  btnLogin:=TJSHTMLButtonElement(document.getelementByID('btnLogin'));
  btnProjects:=TJSHTMLButtonElement(document.getelementByID('btnProjects'));
  btnUsers:=TJSHTMLButtonElement(document.getelementByID('btnUsers'));
  form_parent:=TJSHTMLElement(document.getelementByID('form-parent'));
end;

procedure TIndexForm.BindElementEvents;

begin
  btnLogin.AddEventListener('click', @DoLoginClick);
  btnProjects.AddEventListener('click', @DoProjectsClick);
  btnUsers.AddEventListener('click', @DoUsersClick);
end;

end.
