unit frmProject;
{$MODE ObjFPC}
{$H+}

interface

uses js, web, sysutils, Classes, frmBase, types, webrouter;

type
  
  { --------------------------------------------------------------------
    TProjectDetailForm
    --------------------------------------------------------------------}
  
  { TProjectDetailForm }

  TProjectDetailForm = class(TBaseForm)
  Published
    pagetitle : TJSHTMLElement;
    hdrProjectName : TJSHTMLElement;
    lblNotFound : TJSHTMLElement;
    edtProjectName : TJSHTMLInputElement;
    edtDueDate : TJSHTMLInputElement;
    btnSave : TJSHTMLButtonElement;
    btnCancel : TJSHTMLButtonElement;
  Public
    constructor create(aOwner : TComponent); override;
    procedure BindElements; virtual;
    procedure BindElementEvents; virtual;
    Procedure ShowRoute(Const aURL : String; aRoute : TRoute; aParams : TStrings); override;
    Class function FormHTMLFileName: String; override;
    Class function FormRoutes: TStringDynArray; override;
  end;

implementation


{ --------------------------------------------------------------------
  TProjectDetailForm
  --------------------------------------------------------------------}


constructor TProjectDetailForm.create(aOwner : TComponent);

begin
  inherited;
  BindElements;
  BindElementEvents;
end;



procedure TProjectDetailForm.BindElements;

begin
  pagetitle:=TJSHTMLElement(document.getelementByID('pagetitle'));
  hdrProjectName:=TJSHTMLElement(document.getelementByID('hdrProjectName'));
  lblNotFound:=TJSHTMLElement(document.getelementByID('lblNotFound'));
  edtProjectName:=TJSHTMLInputElement(document.getelementByID('edtProjectName'));
  edtDueDate:=TJSHTMLInputElement(document.getelementByID('edtDueDate'));
  btnSave:=TJSHTMLButtonElement(document.getelementByID('btnSave'));
  btnCancel:=TJSHTMLButtonElement(document.getelementByID('btnCancel'));
end;

procedure TProjectDetailForm.BindElementEvents;

begin
end;

Const
  ProjectCount = 5;
  ProjectNames : Array[1..ProjectCount] of string = (
    'Implement interfaces',
    'Implement libraries',
    'PWA Wizard',
    'Electron Wizard',
    'WebAssembly Widgetset');
  ProjectDates : Array[1..ProjectCount] of string = (
    'May 2018',
    'Februari 2022',
    'March 2022',
    'April 2022',
    'December 2022'
    );


procedure TProjectDetailForm.ShowRoute(const aURL: String; aRoute: TRoute;
  aParams: TStrings);

Const
  NotFound = 'Project "%s" not found!';

Var
  aID : NativeInt;
  aError,aName,aDue : String;

begin
  aID:=StrToInt64Def(aParams.Values['ID'],-1);
  if (aID<1) or (aID>ProjectCount) then
    begin
    aError:=Format(NotFound,[aParams.Values['ID']]);
    lblNotFound.innerText:=aError;
    lblNotFound.classList.remove('is-hidden');
    Exit;
    end;
  aName:=ProjectNames[aID];
  aDue:=ProjectDates[aID];
  hdrProjectName.InnerText:=aName;
  edtProjectName.value:=aName;
  edtDueDate.value:=aDue;
end;

class function TProjectDetailForm.FormHTMLFileName: String;
begin
  Result:='project.html';
end;


class function TProjectDetailForm.FormRoutes: TStringDynArray;
begin
  Result:=['/project/:ID']
end;

end.
